%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Name:      LPsegUI
% Author: 	Junyan Wang and Sai-Kit Yeung
% Lastest version: 2015/1/6
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[imagefiles,datafolder] = uigetfile('*.jpg', 'Choose the image');
mkdir([datafolder,'results\']);
xx_obj =[];
yy_obj =[];
xx_bak = [];
yy_bak = [];

%%
i = 1;
while i<=1
    
    im = imread([datafolder,'\',imagefiles]);
    % Input seeds
    bt = questdlg('Draw new seeds for objects?','Input Seeds');
    figure(1);
    clf;    
    while strcmp(bt,'Yes')
        [x_obj, y_obj] = drawcurve(im,'r');
        xx_obj = [x_obj xx_obj];
        yy_obj = [y_obj yy_obj];
        bt = questdlg('Draw new seeds for objects?','Input Seeds');        
    end
    %
    bt = questdlg('Draw new seeds for background?','Input Seeds');
    while strcmp(bt,'Yes')
        [x_bak, y_bak] = drawcurve(im,'b');
        xx_bak = [x_bak xx_bak];
        yy_bak = [y_bak yy_bak];
        bt = questdlg('Draw new seeds for background?','Input Seeds');
    end
    %%
    load([datafolder,'SPS\',imagefiles(1:end-4),'_sp.mat'],'splabels');
    %[splabels,spbounds]=im2splabel(im,1000);
    xx_obj_clp = xx_obj;
    yy_obj_clp = yy_obj;
    xx_bak_clp = xx_bak;
    yy_bak_clp = yy_bak;
    
    xx_obj_slp = xx_obj;
    yy_obj_slp = yy_obj;
    xx_bak_slp = xx_bak;
    yy_bak_slp = yy_bak;
    
    xx_obj_qp = xx_obj;
    yy_obj_qp = yy_obj;
    xx_bak_qp = xx_bak;
    yy_bak_qp = yy_bak;
    
    xx_obj_sspc = xx_obj;
    yy_obj_sspc = yy_obj;
    xx_bak_sspc = xx_bak;
    yy_bak_sspc = yy_bak;
    
    %%
    if 0
    h = msgbox('Preparing Conventional LP');
    [label_slp,L_slp,ctime_slp]=main_seedseg(im,splabels,xx_obj_slp,yy_obj_slp,xx_bak_slp,yy_bak_slp,'SLP');
    close(h)
    Label_slp = label_slp>0.5;
    end    
    h = msgbox('Preparing Our LP');
    [label_clp,L_clp,ctime_clp]=main_seedseg(im,splabels,xx_obj_clp,yy_obj_clp,xx_bak_clp,yy_bak_clp,'CLP');
    close(h);
    Label_clp = label_clp>0.5;
    if 0
    h = msgbox('Preparing QP');
    [label_qp,L_qp,ctime_qp]=main_seedseg(im,splabels,xx_obj_qp,yy_obj_qp,xx_bak_qp,yy_bak_qp,'QP');
    close(h);
    Label_qp = label_qp>0.5;
    end
    disp(imagefiles);
    %%
    h1=figure(1);
    clf;
    subplot(1,2,1);
    imshow(im);hold on;
    plot(xx_obj_clp,yy_obj_clp,'r.','LineWidth',1);
    plot(xx_bak_clp,yy_bak_clp,'b.','LineWidth',1);title('Input');axis off;
   
    subplot(1,2,2);
    Lrgb2 = label2rgb(Label_clp, 'autumn', 'b', 'shuffle');
    himg = imagesc(Lrgb2);truesize;
    set(himg,'AlphaData',0.8);title('Proposed LP');
    axis off;
    
    btsave = questdlg('Save this result?','Save');
    if ~strcmp(btsave,'Yes')
        continue;
    end
    %%
    save([datafolder,'results\',imagefiles(i).name(1:end-4),'_UserInput_CLP_rst.mat'],'label_clp','splabels','xx_obj_clp','yy_obj_clp','xx_bak_clp','yy_bak_clp','ctime_clp');
    disp(['Img id: ', num2str(i), ', file name: ', imagefiles(i).name]);
    i = i + 1;
    
    xx_obj =[];
    yy_obj =[];
    xx_bak = [];
    yy_bak = [];
    
    
end
